libzypp: zypp::AutoDispose< void >::Impl Struct Reference

libzypp 17.36.6

Public Types | Public Member Functions | Public Attributes | Private Attributes | Related Symbols | List of all members
zypp::AutoDispose< void >::Impl Struct Reference
Inheritance diagram for zypp::AutoDispose< void >::Impl:

## Public Types
using | param_type
using | reference
using | const_reference
using | value_type
using | result_type
using | dispose_param_type
using | Dispose
| Dispose function signatue.

## Public Member Functions
| Impl ()
| Impl (Dispose dispose_r)
| ~Impl ()
| Impl (T &&value_r)
| Impl (T &&value_r, D &&dispose_r)
| ~Impl ()
| AutoDispose ()
| Default Ctor using default constructed value and no dispose function.
| AutoDispose (Dispose dispose_r)
| Ctor taking dispose function and using default constructed value.
| AutoDispose (value_type value_r)
| Ctor taking value and no dispose function.
| AutoDispose (value_type value_r, Dispose dispose_r)
| Ctor taking value and dispose function.
| operator reference () const
| Provide implicit conversion to `Tp&`.
reference | value () const
| Reference to the `Tp` object.
reference | operator* () const
| Reference to the `Tp` object.
value_type * | operator-> () const
| Pointer to the `Tp` object (asserted to be `!= NULL`).
void | reset ()
| Reset to default Ctor values.
void | swap (AutoDispose &rhs) noexcept
| Exchange the contents of two AutoDispose objects.
bool | unique () const
| Returns true if this is the only AutoDispose instance managing the current data object.
const Dispose & | getDispose () const
| Return the current dispose function.
void | setDispose (const Dispose &dispose_r)
| Set a new dispose function.
void | resetDispose ()
| Set no dispose function.
void | swapDispose (Dispose &dispose_r)
| Exchange the dispose function.

## Public Attributes
Dispose | _dispose
value_type | _value
Dispose | _dispose

## Private Attributes
shared_ptr< Impl > | _pimpl

## Related Symbols
(Note that these are not member symbols.)
std::ostream & | operator<< (std::ostream &str, const AutoDispose< void > &obj)
| Stream output of the `Tp` object.
std::ostream & | operator<< (std::ostream &str, const AutoDispose< void > &obj)
| Stream output of the `Tp` object.

## Detailed Description

Definition at line 248 of file AutoDispose.h.

## Member Typedef Documentation

## ◆ param_type

using zypp::AutoDispose< void >::param_type

Definition at line 97 of file AutoDispose.h.

## ◆ reference

using zypp::AutoDispose< void >::reference

Definition at line 98 of file AutoDispose.h.

## ◆ const_reference

using zypp::AutoDispose< void >::const_reference

Definition at line 99 of file AutoDispose.h.

## ◆ value_type

using zypp::AutoDispose< void >::value_type

Definition at line 100 of file AutoDispose.h.

## ◆ result_type

using zypp::AutoDispose< void >::result_type

Definition at line 101 of file AutoDispose.h.

## ◆ dispose_param_type

using zypp::AutoDispose< void >::dispose_param_type

Definition at line 104 of file AutoDispose.h.

## ◆ Dispose

using zypp::AutoDispose< void >::Dispose

Dispose function signatue.

Definition at line 108 of file AutoDispose.h.

## Constructor & Destructor Documentation

## ◆ Impl() [1/4]

zypp::AutoDispose< void >::Impl::Impl | ( |  | ) |
| inline

Definition at line 250 of file AutoDispose.h.

## ◆ Impl() [2/4]

zypp::AutoDispose< void >::Impl::Impl | ( | Dispose | dispose_r | ) |
| inline

Definition at line 253 of file AutoDispose.h.

## ◆ ~Impl() [1/2]

zypp::AutoDispose< void >::Impl::~Impl | ( |  | ) |
| inline

Definition at line 257 of file AutoDispose.h.

## ◆ Impl() [3/4]

zypp::AutoDispose< void >::Impl::Impl | ( | T && | value_r | ) |
| inline

Definition at line 182 of file AutoDispose.h.

## ◆ Impl() [4/4]

zypp::AutoDispose< void >::Impl::Impl | ( | T && | value_r,
|  | D && | dispose_r )
| inline

Definition at line 186 of file AutoDispose.h.

## ◆ ~Impl() [2/2]

zypp::AutoDispose< void >::Impl::~Impl | ( |  | ) |
| inline

Definition at line 190 of file AutoDispose.h.

## Member Function Documentation

## ◆ AutoDispose() [1/4]

zypp::AutoDispose< void >::AutoDispose | ( |  | ) |
| inline

Default Ctor using default constructed value and no dispose function.

Definition at line 112 of file AutoDispose.h.

## ◆ AutoDispose() [2/4]

zypp::AutoDispose< void >::AutoDispose | ( | Dispose | dispose_r | ) |
| inlineexplicit

Ctor taking dispose function and using default constructed value.

Definition at line 117 of file AutoDispose.h.

## ◆ AutoDispose() [3/4]

zypp::AutoDispose< void >::AutoDispose | ( | value_type | value_r | ) |
| inlineexplicit

Ctor taking value and no dispose function.

Definition at line 122 of file AutoDispose.h.

## ◆ AutoDispose() [4/4]

zypp::AutoDispose< void >::AutoDispose | ( | value_type | value_r,
|  | Dispose | dispose_r )
| inline

Ctor taking value and dispose function.

Definition at line 127 of file AutoDispose.h.

## ◆ operator reference()

zypp::AutoDispose< void >::operator reference | ( |  | ) | const
| inline

Provide implicit conversion to `Tp&`.

Definition at line 134 of file AutoDispose.h.

## ◆ value()

reference zypp::AutoDispose< void >::value | ( |  | ) | const
| inline

Reference to the `Tp` object.

Definition at line 138 of file AutoDispose.h.

## ◆ operator*()

reference zypp::AutoDispose< void >::operator* | ( |  | ) | const
| inline

Reference to the `Tp` object.

Definition at line 142 of file AutoDispose.h.

## ◆ operator->()

value_type * zypp::AutoDispose< void >::operator-> | ( |  | ) | const
| inline

Pointer to the `Tp` object (asserted to be `!= NULL`).

Definition at line 146 of file AutoDispose.h.

## ◆ reset()

void zypp::AutoDispose< void >::reset | ( |  | ) |
| inline

Reset to default Ctor values.

Definition at line 150 of file AutoDispose.h.

## ◆ swap()

void zypp::AutoDispose< void >::swap | ( | AutoDispose< void > & | rhs | ) |
| inlinenoexcept

Exchange the contents of two AutoDispose objects.

Definition at line 154 of file AutoDispose.h.

## ◆ unique()

bool zypp::AutoDispose< void >::unique | ( |  | ) | const
| inline

Returns true if this is the only AutoDispose instance managing the current data object.

Definition at line 158 of file AutoDispose.h.

## ◆ getDispose()

const Dispose & zypp::AutoDispose< void >::getDispose | ( |  | ) | const
| inline

Return the current dispose function.

Definition at line 163 of file AutoDispose.h.

## ◆ setDispose()

void zypp::AutoDispose< void >::setDispose | ( | const Dispose & | dispose_r | ) |
| inline

Set a new dispose function.

Definition at line 167 of file AutoDispose.h.

## ◆ resetDispose()

void zypp::AutoDispose< void >::resetDispose | ( |  | ) |
| inline

Set no dispose function.

Definition at line 171 of file AutoDispose.h.

## ◆ swapDispose()

void zypp::AutoDispose< void >::swapDispose | ( | Dispose & | dispose_r | ) |
| inline

Exchange the dispose function.

Definition at line 175 of file AutoDispose.h.

## Friends And Related Symbol Documentation

## ◆ operator<<() [1/2]

std::ostream & operator<< | ( | std::ostream & | str,
|  | const AutoDispose< void > & | obj )
| related

Stream output of the `Tp` object.

Definition at line 300 of file AutoDispose.h.

## ◆ operator<<() [2/2]

std::ostream & operator<< | ( | std::ostream & | str,
|  | const AutoDispose< void > & | obj )
| related

Stream output of the `Tp` object.

Definition at line 300 of file AutoDispose.h.

## Member Data Documentation

## ◆ _dispose [1/2]

Dispose zypp::AutoDispose< void >::Impl::_dispose

Definition at line 262 of file AutoDispose.h.

## ◆ _value

value_type zypp::AutoDispose< void >::Impl::_value

Definition at line 195 of file AutoDispose.h.

## ◆ _dispose [2/2]

Dispose zypp::AutoDispose< void >::Impl::_dispose

Definition at line 196 of file AutoDispose.h.

## ◆ _pimpl

shared_ptr<Impl> zypp::AutoDispose< void >::_pimpl
| private

Definition at line 199 of file AutoDispose.h.

The documentation for this struct was generated from the following file:

- zypp-core/AutoDispose.h